/*
 * Copyright 2021 Layotto Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package common

import (
	"crypto/md5"
	"encoding/hex"
)

func CalculateMd5(str string) string {
	md5Calculator := md5.New()
	md5Calculator.Write([]byte(str))
	data := md5Calculator.Sum(nil)
	value := hex.EncodeToString(data)
	return value
}

func CalculateMd5ForBytes(bytes []byte) string {
	md5Calculator := md5.New()
	md5Calculator.Write(bytes)
	data := md5Calculator.Sum(nil)
	value := hex.EncodeToString(data)
	return value
}
